﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ExcelFilter;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
using MVCSampleBrowser.Models;
namespace ExcelFilter.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            return View();
        }
        public ActionResult Data(DataManager dataManager)
        {
            IEnumerable data = OrderRepository.GetAllRecords().ToList(); // Grid Data
            DataResult result = new DataResult();
            int count = data.AsQueryable().Count();
            DataOperations operation = new DataOperations();
            if (dataManager.Where != null && (dataManager.Where[0].predicates != null || dataManager.Where[0].value != null) && dataManager.Where.Count > 0) //Filtering
            {
                data = operation.PerformWhereFilter(data, dataManager.Where,"and");
                var filtered = (IEnumerable)data;
                count = filtered.AsQueryable().Count();
            }
            if (dataManager.Skip != 0)
            {
                data = operation.PerformSkip(data, dataManager.Skip);
            }
            if (dataManager.Take != 0)
            {
                data = operation.PerformTake(data, dataManager.Take);
            }

            result.result = data;
            result.count = count;
            return Json(result, JsonRequestBehavior.AllowGet);

        }
        public ActionResult DataSource()
        {
            var data = new NorthwindDataContext().OrdersViews.Select(e=>e.EmployeeID).Distinct().ToList();
            return Json(data, JsonRequestBehavior.AllowGet);

        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
    }
}
